#ifndef MEMORY_H
#define MEMORY_H

void *memcpy(void*, void*, unsigned long);
void *memset(void *, unsigned char , unsigned long );
void SetupPaging();
unsigned char LoadPageDirectory(unsigned long);
unsigned char SetPage ( unsigned long, unsigned long, unsigned long);
unsigned char MapMemory ( unsigned long , unsigned long , unsigned long , unsigned long );

void *malloc(unsigned long);
void *realloc(void *, unsigned long);
signed char free(void *);

/***************************************/
//Defines
#define PAGE_PRE       	0x01
#define PAGE_RW			0x02
#define PAGE_US			0x04
#define PAGE_PWT		0x08
#define PAGE_PCD		0x10
#define PAGE_ACC		0x20
#define PAGE_DTY        0x40
#define PAGE_PAT        0x80
#define PAGE_GLB        0x100


#endif
