#ifndef msg_h_
#define msg_h_  0.01
#define MAILMAX     50
#define MAILSAFE    25
#include <x32.h>
typedef struct
{
        uint32_t cm;
        uint32_t *data;
        uint32_t *extra;
        }__attribute__((packed)) mail_t;
typedef struct
{
        mail_t mail[MAILMAX];
        }__attribute__((packed)) box_t;
#define   MSG_IDLE                     12        
#define   MSG_READ                     11
#define   MSG_WRITE                    10
#define   MSG_DELETE                   9
#define   MSG_COPY                     8
#define   MSG_IOCTL                    7
#define   MSG_KILL                     6
#define   MSG_WAIT                     5
#define   MSG_RESUME                   4
#define   MSG_LIST                     3
#define   MSG_SEND                     2
#define   MSG_REQUEST                  1
#define   MSG_OK                       0
#define   MSG_NOK                      -1    
#define   MSGT_SYS                     2
#define   MSGT_USER                    1
#define   MSGT_OS                      0   



uint8_t init_msg();
int msgsetup();
mail_t *msgget(int boxnum);
int msgsend(int boxnum, mail_t *nmail);
int msgrefresh(int boxnum);
int msgdelete(int boxnum);
#endif
