/* bkerndev - Bran's Kernel Development Tutorial
*  By:   Brandon F. (friesenb@gmail.com)
*  Desc: Main.c: C code entry.
*
*  Notes: No warranty expressed or implied. Use at own risk. */
#include <system.h>
#include <mm/mm.h>
#include <sys/msg.h>

unsigned short *memsetw(unsigned short *dest, unsigned short val, size_t count)
{
    unsigned short *temp = (unsigned short *)dest;
    for( ; count != 0; count--) *temp++ = val;
    return dest;
}
int test(int x, int num);
void task1()
{
     int box = TaskBoxId();
     mail_t *mail;
     int x = -2;
     puts("hello from task1\n");
     while(1)
     {
     x++;
     mail = msgget(box);
     if(mail->cm == MSG_IDLE) puts("msg idle\n");
     if(mail->cm == MSG_READ) puts("msg read\n");
     if(mail->cm == MSG_WRITE) puts("msg write\n");
     if(mail->cm == MSG_IOCTL) puts("msg ioctl\n");
     if(mail->cm == MSG_COPY) puts("msg copy\n");
     if(mail->cm == MSG_DELETE) puts("msg delete\n");
     if(mail->cm == MSG_LIST) puts("msg list\n");
     if(mail->cm == MSG_SEND) puts("msg send\n");
     if(mail->cm == MSG_REQUEST) puts("msg request\n");
     if(mail->cm == MSG_OK) puts("msg ok\n");
     if(mail->cm == MSG_NOK) puts("msg nok\n");
     if(mail->cm == MSG_RESUME) puts("msg resume\n");
     if(mail->cm == MSG_WAIT) puts("msg wait\n");
     msgrefresh(box);
     test(x, box);
     }
     }
     
     

void task2()
{
     while (1);
     }
     int test(int x, int num)
     {
        mail_t *mail = (mail_t*) malloc(sizeof(mail_t));
        mail->cm = x;
        msgsend(num, mail);
        } 

void main()
{
    int i;

    gdt_install();
    idt_install();
    isrs_install();
    irq_install();
    init_video();
    timer_install();
    init_msg();
   // SetupScheduler();
    keyboard_install();
    SetupPaging();
    

    __asm__ __volatile__ ("sti");

    puts("Hello World!\n");

//    i = 10 / 0;
//    putch(i);

    for (;;);
}
