#include <sys/msg.h>
#include <system.h>
//#include <task/multi.h>
#include <mm/mm.h>


box_t *mail;

int used[MAILMAX];
#define T_FREE    11
#define T_USED    12
uint8_t init_msg()
{
        mail = (box_t*)malloc(sizeof(box_t));
        int x = 0;
        while(x < MAILMAX)
        {
                used[x] = T_FREE;
                x++;
                }
                }
int msgfindfree()
{
    int x = 0;
    while(x < MAILMAX)
        {
                if(used[x] == T_FREE) return x;
                x++;
                }
                return -1;
                }
    
int msgsetup()
{
        int x = msgfindfree();
        if(x == -1) return -1;
        used[x] = T_USED;
        return x;
        }
mail_t *msgget(int boxnum)
{       
        mail_t *nmail;
        nmail = (mail_t *) malloc(sizeof(mail_t));
        nmail->cm = mail->mail[boxnum].cm;
        nmail->data = mail->mail[boxnum].data;
        nmail->extra = mail->mail[boxnum].extra;
        return nmail;
        }
int msgsend(int boxnum, mail_t *nmail)
{
    mail->mail[boxnum].cm = nmail->cm;
    mail->mail[boxnum].data = nmail->data;
    mail->mail[boxnum].extra = nmail->extra;
    return 0;
}
int msgrefresh(int boxnum)
{
    free(mail->mail[boxnum].data);
    free(mail->mail[boxnum].extra);
    mail->mail[boxnum].cm = MSG_IDLE;
    return 0;
}
int msgdelete(int boxnum)
{
    free(mail->mail[boxnum].data);
    free(mail->mail[boxnum].extra);
    used[boxnum] = T_FREE;
    return 0;
}
